#include "WProgram.h"
#include "TCS230.h"

//constructor
TCS230::TCS230(int gnd, int oe, int out, int s0, int s1, int s2, int s3, int vdd)
{
	_gnd = gnd; _oe = oe; _s1 = s1; _s0 = s0; _s2 = s2; _s3 = s3; _out = out; _vdd = vdd; 
    pinMode(_gnd, OUTPUT); pinMode(_oe, OUTPUT); pinMode(_s0, OUTPUT); pinMode(_s1, OUTPUT); 
    pinMode(_s2, OUTPUT); pinMode(_s3, OUTPUT); pinMode(_out, INPUT); pinMode(_vdd, OUTPUT); 
 
}

//default constructor
TCS230::TCS230() //call this function in order to use John Sarik's TCS230-Arduino Board
{
	_gnd = 8; _oe = 7; _s1 = 6; _s0 = 5; _s2 = 3; _s3 = 4; _out = 2; _vdd = 9; 
    pinMode(_gnd, OUTPUT); pinMode(_oe, OUTPUT); pinMode(_s0, OUTPUT); pinMode(_s1, OUTPUT); 
    pinMode(_s2, OUTPUT); pinMode(_s3, OUTPUT); pinMode(_out, INPUT); pinMode(_vdd, OUTPUT); 
 
}

//color reading functions
int  TCS230::readRed()
{
	int value; //value to store reading
	
	//set the color to be read	
	digitalWrite(_s2, LOW); 
    digitalWrite(_s3, LOW); 
	
	//read from the output pin
	if (digitalRead(_out) == HIGH)
       value = pulseIn(_out, LOW); 
    else
       value = pulseIn(_out, HIGH);
	   
	return value; //return value to user
}

int  TCS230::readBlue()
{
	int value; //value to store reading
	
	//set the color to be read	
	digitalWrite(_s2, LOW); 
    digitalWrite(_s3, HIGH); 

	//read from the output pin
	if (digitalRead(_out) == HIGH)
       value = pulseIn(_out, LOW); 
    else
       value = pulseIn(_out, HIGH);
	   
	return value; //return value to user
}

int  TCS230::readClear()
{
	int value; //value to store reading
	
	//set the color to be read	
	digitalWrite(_s2, HIGH); 
    digitalWrite(_s3, LOW); 
	
	//read from the output pin
	if (digitalRead(_out) == HIGH)
       value = pulseIn(_out, LOW); 
    else
       value = pulseIn(_out, HIGH);
	   
	return value; //return value to user
}

int  TCS230::readGreen()
{
	int value; //value to store reading
	
	//set the color to be read	
	digitalWrite(_s2, HIGH); 
    digitalWrite(_s3, HIGH); 

	//read from the output pin
	if (digitalRead(_out) == HIGH)
       value = pulseIn(_out, LOW); 
    else
       value = pulseIn(_out, HIGH);	
	   
	return value; //return value to user
}

void TCS230::initialize()
{
	digitalWrite(_gnd, LOW); //give the sensor ground
    digitalWrite(_vdd, HIGH); //give the sensor power
    digitalWrite(_oe, LOW); //turn on output
	
	delay(1); 
   
    //2% frequency scaling
    digitalWrite(_s0, LOW); 
    digitalWrite(_s1, HIGH); 

}